POJ 2253

题目链接:http://poj.org/problem?id=2253

                                                          Frogger

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 71988 Accepted: 22065

Description

Freddy Frog is sitting on a stone in the middle of a lake. Suddenly he notices Fiona Frog who is sitting on another stone. He plans to visit her, but since the water is dirty and full of tourists' sunscreen, he wants to avoid swimming and instead reach her by jumping. 
Unfortunately Fiona's stone is out of his jump range. Therefore Freddy considers to use other stones as intermediate stops and reach her by a sequence of several small jumps. 
To execute a given sequence of jumps, a frog's jump range obviously must be at least as long as the longest jump occuring in the sequence. 
The frog distance (humans also call it minimax distance) between two stones therefore is defined as the minimum necessary jump range over all possible paths between the two stones. 

You are given the coordinates of Freddy's stone, Fiona's stone and all other stones in the lake. Your job is to compute the frog distance between Freddy's and Fiona's stone. 

Input

The input will contain one or more test cases. The first line of each test case will contain the number of stones n (2<=n<=200). The next n lines each contain two integers xi,yi (0 <= xi,yi <= 1000) representing the coordinates of stone #i. Stone #1 is Freddy's stone, stone #2 is Fiona's stone, the other n-2 stones are unoccupied. There's a blank line following each test case. Input is terminated by a value of zero (0) for n.

Output

For each test case, print a line saying "Scenario #x" and a line saying "Frog Distance = y" where x is replaced by the test case number (they are numbered from 1) and y is replaced by the appropriate real number, printed to three decimals. Put a blank line after each test case, even after the last one.

Sample Input

2
0 0
3 4

3
17 4
19 4
18 5

0

Sample Output

Scenario #1
Frog Distance = 5.000

Scenario #2
Frog Distance = 1.414

题意:公青蛙找母青蛙一起玩耍,要跳过很多石头,求在跳过路径最短情况下一次需要跳的最大距离。

思路:最短路径的题,可以用dijkstra算法,但我用的最小生成树。

代码可以在poj上通过,但在vjudge上re,不知为何。

#include<cstdio>
#include<cmath>
#include<iostream>
#include<algorithm>
using namespace std;
int t,c,x,y;
int a[1005][1005];
int pre[10005];
struct edge{
	int a;
	int b;
	double val;
}e[10005];
bool cmp(edge e1,edge e2){
	return e1.val <e2.val ;
}
int find(int x){
	int r=x;
	while(r!=pre[r])
	r=pre[r];
	int k=x,j;
	while(k!=r)
	{
		j=pre[k];
		pre[k]=r;
		k=j;
	}
	return r;
}
void join(int x,int y)
{
	int fx=find(x),fy=find(y);
	if(fx!=fy)
	pre[fx]=fy;
} 
int main(){
	int d=0;
	while(~scanf("%d",&c),c)
	{
		d++;
	for(int i=1;i<=c;i++)	
		scanf("%d %d",&a[i][0],&a[i][1]);
	for(int i=1;i<=c;i++)
		pre[i]=i;	
    int k=1;//记录有多少个距离值		
	for(int i=1;i<=c-1;i++)
		for(int j=i+1;j<=c;j++)
		{
			e[k].a=i;
			e[k].b=j;
			e[k].val=sqrt(pow(a[i][0]-a[j][0],2.0)+pow(a[i][1]-a[j][1],2.0));
			k++;
		}		
	sort(e+1,e+k,cmp);//注意k会多一		
	double sum=0.0;
	for(int i=1;i<=k-1;i++)
	{
		if(find(e[i].a )!=find(e[i].b ))
		{	
			join(e[i].a,e[i].b );
			if(find(1)==find(2)) //两青蛙所在点连通则保存直接跳出
			{
				sum=e[i].val;//距离值从小到大排列,若在此点连通则此时距离值即为青蛙跳的最远值
				break;
			}
		}
	}
		printf("Scenario #%d\n",d);
		printf("Frog Distance = %.3lf\n\n",sum);//注意,两次换行
	}
	return 0;
}

此题和HDU 1875题很像:http://acm.hdu.edu.cn/showproblem.php?pid=1875,可以做着试试。

  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值